#include <FastLED.h>
#include "./Geometry.h"
#include <functional>

class Display;

class Surface {
public:
    Surface(Display* dpy, const VirtualCoordinates& start, const VirtualCoordinates& end);

    Surface& operator=(const CRGB& color);
    Surface& operator+=(const CRGB& color);

    void paintWith(std::function<void(CRGB&)> func);

    const PhysicalCoordinates start;
    const PhysicalCoordinates end;

private:
    Display* m_display;
};
